unit xCheckOs;
  { check under which operating system we currently run }

{
  20.10.98 sb Now checked under Windows98
  04.11.98 sb getVersionInfo() lieferter keine Werte an Aufrufer zurck 
}

interface

uses
  Windows;

type
  TCheckOs = class
  private
    class function getVersionInfo(var aVersion: TOSVersionInfo): Boolean;
  public
    // Windows NT
    class function NT351: Boolean;
    class function NT4: Boolean;
    class function NT5: Boolean;

    // Windows 95/98
    class function Win95: Boolean;
    class function Win98: Boolean;
  end;

implementation

{ TCheckOs }

class function TCheckOs.getVersionInfo(var aVersion: TOSVersionInfo): Boolean;
begin
  aVersion.dwOSVersionInfoSize:= SizeOf(aVersion);
  Result:= GetVersionEx(aVersion);
end;

class function TCheckOs.NT351: Boolean;
var
  aVersion: TOSVersionInfo;
begin
  Result := getVersionInfo(aVersion) and
    (aVersion.dwPLatformId = VER_PLATFORM_WIN32_NT) and
    (aVersion.dwMajorVersion = 3) and (aVersion.dwMinorVersion = 51);
end;

class function TCheckOs.NT4: Boolean;
var
  aVersion: TOSVersionInfo;
begin
  Result := getVersionInfo(aVersion) and
    (aVersion.dwPLatformId = VER_PLATFORM_WIN32_NT) and
    (aVersion.dwMajorVersion = 4);
end;

class function TCheckOs.NT5: Boolean;
var
  aVersion: TOSVersionInfo;
begin
  Result := getVersionInfo(aVersion) and
    (aVersion.dwPLatformId = VER_PLATFORM_WIN32_NT) and
    (aVersion.dwMajorVersion = 5);
end;

class function TCheckOs.Win95: Boolean;
var
  aVersion: TOSVersionInfo;
begin
  Result := getVersionInfo(aVersion) and
    (aVersion.dwPLatformId = VER_PLATFORM_WIN32_WINDOWS) and
    (aVersion.dwMajorVersion = 4) and (aVersion.dwMinorVersion < 10);
end;

class function TCheckOs.Win98: Boolean;
var
  aVersion: TOSVersionInfo;
begin
  Result := getVersionInfo(aVersion) and
    (aVersion.dwPLatformId = VER_PLATFORM_WIN32_WINDOWS) and
    (aVersion.dwMajorVersion = 4) and (aVersion.dwMinorVersion >= 10);

end;

end.
