unit xProcBit;
  { bit maniuplating }

interface

const
  { common computer sizes }
  KBYTE               = Sizeof(Byte) shl 10;
  MBYTE               = KBYTE        shl 10;
  GBYTE               = MBYTE        shl 10;

  { count of bits per Integer-type }
  BITS_PER_BYTE       = 8;
  BYTE_BIT_COUNT      = Sizeof( Byte )    * BITS_PER_BYTE;
  WORD_BIT_COUNT      = Sizeof( Word )	  * BITS_PER_BYTE;
  LONGINT_BIT_COUNT   = Sizeof( Longint ) * BITS_PER_BYTE;
  INTEGER_BIT_COUNT   = Sizeof( Integer ) * BITS_PER_BYTE;

type
  TBit      = 0..31;

  TBitUtils = class
  public
    class function isSet(const aValue: Integer; const aBit: TBit): Boolean;
    class function setOn(const aValue: Integer; const aBit: TBit): Integer;
    class function setOff(const aValue: Integer; const aBit: TBit): Integer;
    class function Toggle(const aValue: Integer; const aBit: TBit): Integer;
  end;

implementation

{ TBitUtils }

class function TBitUtils.isSet(const aValue: Integer; const aBit: TBit): Boolean;
begin
  Result:= (aValue and (1 shl aBit)) <> 0;
end;

class function TBitUtils.setOn(const aValue: Integer; const aBit: TBit): Integer;
begin
  Result := aValue or (1 shl aBit);
end;

class function TBitUtils.setOff(const aValue: Integer; const aBit: TBit): Integer;
begin
  Result := aValue and ((1 shl aBit) xor $FFFFFFFF);
end;

class function TBitUtils.Toggle(const aValue: Integer; const aBit: TBit): Integer;
begin
  result := aValue xor (1 shl aBit);
end;

end.
