unit xVersion;
  { Versionsinformation ermitteln }

{
  23.09.98 sb Angepasst an Delphi 4.0 
}

interface

uses
  SysUtils,
{$IFDEF Win32}
  Windows
{$ELSE}
  WinTypes,WinProcs,Ver
{$ENDIF}
  ;

type
  EVersionError = class(Exception)
  end;

  TFileVersion = class
  private
    fLen  : Longint;
    fData : Pointer;
    function GetVersion: String;
  public
    constructor Create;
    destructor Destroy; override;
    function GetString(aItem: String): String;
    property Version: String read GetVersion;
  end;

implementation

constructor TFileVersion.Create;
var
 {$IFDEF Win32}
  aHandle: dWord;
 {$ELSE}
  aHandle: Longint;
 {$ENDIF}
  aTmp: array[0..255] of char;
begin
  StrPCopy(aTmp,ParamStr(0));
  fLen:=GetFileVersionInfoSize(aTmp,aHandle);
  if fLen=0 then raise EVersionError.Create('No version information aviable');
  getmem(fData,fLen);
  if not GetFileVersionInfo(aTmp,0,fLen,fData) then
     raise EVersionError.Create('No version information aviable');
end;

destructor TFileVersion.Destroy;
begin
  freemem(fData,fLen);
  inherited Destroy;
end;

function TFileVersion.GetVersion: String;
var
  aData : Pointer;
 {$IFDEF Win32}
  aLen  : dWord;
 {$ELSE}
  aLen  : Word;
 {$ENDIF}
begin
  Result:='';
  if VerQueryValue(fData,'\',aData,aLen) then
    {$IFDEF Win32}
     with PVSFixedFileInfo(aData)^ do
    {$ELSE}
     with PVS_FixedFileInfo(aData)^ do
    {$ENDIF}
       Result := IntToStr(LongRec(dwFileVersionMS).Hi)+'.'+
                 IntToStr(LongRec(dwFileVersionMS).Lo)+'.'+
                 IntToStr(LongRec(dwFileVersionLS).Hi)+'.'+
                 IntToStr(LongRec(dwFileVersionLS).Lo);
end;

function TFileVersion.GetString(aItem: String): String;
var
  aData : Pointer;
 {$IFDEF Win32}
  aLen  : dWord;
 {$ELSE}
  aLen  : Word;
 {$ENDIF}
  aTmp  : array[0..100] of char;
begin
  StrPCopy(aTmp,'\StringFileInfo\040704E4\'+aItem);
  Result:='';
  if VerQueryValue(fData,aTmp,aData,aLen) then
     Result:=StrPas(PChar(aData));
end;

end.
